#include "AllCommands.h"

Auto3ToteToZone::Auto3ToteToZone(double wait) {
	m_cancel = false;

	AddSequential(new WaitCommand(wait));
	AddParallel(new AutoPickupTote());																			// Start pickup sequence for totes 1 & 2
	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, true, 0, Drive::fNewMark, 136, 0.4, 0));	// Start drive to 3rd tote
	AddSequential(new ElevWaitForOnTarget());																	// Wait for elevator to lift 2nd tote
	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, true, 0, Drive::fMark, 24, 0.7, 0));		// Drive over 3rd tote
	AddSequential(new ElevSetToteCenter(Elevator::sOn));														// Use kickers to grab tote
	AddSequential(new DriveAutoRotate(&m_cancel, 0, 90, Drive::fMark, 0.7));									// Rotate 90 degrees
	AddSequential(new ElevSetToteCenter(Elevator::sOff));														// Release tote
	AddSequential(new DriveAutoDriveElev(&m_cancel, 0, true, Drive::eBoth, true, 90, Drive::fMark, 120, 0.8, 0, 60, Elevator::pStep));  // Drive to zone
	AddSequential(new ElevWaitForOnTarget());																	// Wait for elevator to release totes
	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, true, 90, Drive::fMark, -14, 0.7, 0));	// Backup

//	AddSequential(new WaitCommand(wait));
//	AddSequential(new ElevSetPosition(Elevator::pStepTote));													// Raise elevator
//	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, true, 0, Drive::fNewMark, 90, 0.6, 0));	// 78 Drive to next tote
//	AddSequential(new ElevAutoCenter());																		// Center tote with kickers
//	AddSequential(new ElevSetPosition(Elevator::pLiftFromFloor));												// Lower elevator to pickup tote
//	AddSequential(new ElevWaitForOnTarget());
//	AddParallel  (new ElevSetPosition(Elevator::pStepTote));													// Raise elevator
//	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, true, 0, Drive::fMark, 68, 0.7, 0));		// 80 Drive to next tote
//	AddSequential(new ElevSetToteCenter(Elevator::sOn));														// Use kickers to grab tote
//	AddSequential(new DriveAutoRotate(&m_cancel, 0, 90, Drive::fMark, 0.7));									// Rotate 90 degrees
//	AddSequential(new ElevSetToteCenter(Elevator::sOff));														// Release tote
//	AddSequential(new DriveAutoDriveElev(&m_cancel, 0, true, Drive::eBoth, true, 90, Drive::fMark, 114, 0.8, 0, 60, Elevator::pStep));
//	AddSequential(new ElevWaitForOnTarget());																	// Drive forward, lower elevator
//	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, true, 90, Drive::fMark, -14, 0.7, 0));	// Backup
}

bool Auto3ToteToZone::IsFinished() {
	return m_cancel ? true : CommandGroup::IsFinished();
}
