#include "AllCommands.h"

AutoBinToFeederL::AutoBinToFeederL(double wait) {
	m_cancel = false;

	AddSequential(new WaitCommand(wait));
	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, true, 0, Drive::fNewMark, 30, 0.6, 0));		// Drive forward, tip bin over
	AddSequential(new DriveSetFeederAngle(true));																	// Set Feeder angle using sonar
	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, false, 0, Drive::fFeeder, 4, 0.5, 0));		// Rotate to feeder
	AddSequential(new WaitCommand(1.0));																			// Wait for bin to settle
	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, true, 0, Drive::fFeeder, -22, 0.6, 0));		// Backup
	AddSequential(new ElevSetPosition(Elevator::pBinLoad));															// Lower elevator
	AddSequential(new ElevWaitForOnTarget());
	AddSequential(new DriveAutoDrive(&m_cancel, 3.0, true, Drive::eBoth, false, 0, Drive::fFeeder, 24, 0.5, 0));	// Drive forward, load bin
	AddSequential(new ElevSetPosition(Elevator::pCarry));															// Raise elevator
	AddSequential(new ElevWaitForOnTarget());
	AddSequential(new DriveAutoDrive(&m_cancel, 2.0, true, Drive::eBoth, false, 0, Drive::fFeeder, 4, 0.6, 0));		// Drive forward, push bin in
	AddSequential(new ElevSetPosition(Elevator::pFeederLoad));														// Raise elevator
	AddSequential(new ElevWaitForOnTarget());
	AddSequential(new DriveSetFeederAngle(true));																	// Reset Feeder angle using sonar
	AddSequential(new DriveAutoRotate(&m_cancel, 0, 0, Drive::fFeeder, 0.7));										// Rotate to feeder

//	AddSequential(new WaitCommand(wait));
//	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, true, 0, Drive::fNewMark, 32, 0.6));		// Drive forward, tip bin over
//	AddSequential(new WaitCommand(1.0));																		// Wait for bin to settle
//	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, false, 0, Drive::fMark, -22, 0.6));		// Backup
//	AddSequential(new ElevSetPosition(Elevator::pBinLoad));														// Lower elevator
//	AddSequential(new ElevWaitForOnTarget());
//	AddSequential(new DriveSetFeederAngle(true));																// Set Feeder angle using sonar
//	AddSequential(new DriveAutoDrive(&m_cancel, 3.0, true, Drive::eBoth, false, 0, Drive::fMark, 22, 0.5));		// Drive forward, load bin
//	AddSequential(new DriveAutoRotate(&m_cancel, 0, 0, Drive::fFeeder, 0.7));									// Rotate to feeder
//	AddSequential(new ElevSetPosition(Elevator::pFeederLoad));													// Raise elevator
//	AddSequential(new ElevWaitForOnTarget());
//	AddSequential(new DriveSetFeederAngle(true));																// Reset Feeder angle using sonar
//	AddSequential(new DriveAutoRotate(&m_cancel, 0, 0, Drive::fFeeder, 0.7));									// Rotate to feeder
//	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, false, 0, Drive::fFeeder, 5, 0.6));		// Drive forward, push bin in
}

bool AutoBinToFeederL::IsFinished() {
	return m_cancel ? true : CommandGroup::IsFinished();
}

