#include "AllCommands.h"

AutoBinToFeederR::AutoBinToFeederR(double wait) {
	m_cancel = false;

	AddSequential(new WaitCommand(wait));
	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, true, 0, Drive::fNewMark, 58, 0.6, 0));	// Drive forward, tip bin over
	AddSequential(new DriveSetFeederAngle(true)); 																// Square Up
	AddSequential(new DriveAutoRotate(&m_cancel, 0, 0, Drive::fFeeder, 0.7));									// Rotate to feeder
	AddSequential(new WaitCommand(1.0));																		// Wait for settle
	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, true, 0, Drive::fFeeder, -22, 0.6, 0));	// Back out
	AddSequential(new ElevSetPosition(Elevator::pBinLoad));														// Lower elevator
	AddSequential(new ElevWaitForOnTarget());
	AddSequential(new DriveAutoDrive(&m_cancel, 3.0, true, Drive::eBoth, false, 0, Drive::fFeeder, 24, 0.5, 0));// Drive forward, load bin
	AddSequential(new ElevSetPosition(Elevator::pCarry));														// Raise elevator
	AddSequential(new ElevWaitForOnTarget());
	AddSequential(new DriveAutoDrive(&m_cancel, 2.0, true, Drive::eBoth, false, 0, Drive::fFeeder, 4, 0.6, 0));	// Drive forward, push bin in
	AddSequential(new ElevSetPosition(Elevator::pFeederLoad));													// Raise elevator
	AddSequential(new ElevWaitForOnTarget());
	AddSequential(new DriveSetFeederAngle(true));																// Reset Feeder angle using sonar
	AddSequential(new DriveAutoRotate(&m_cancel, 0, 0, Drive::fFeeder, 0.7));									// Rotate to feeder
}

bool AutoBinToFeederR::IsFinished() {
	return m_cancel ? true : CommandGroup::IsFinished();
}
