#include "AllCommands.h"

AutoBinToWall::AutoBinToWall(double wait) {
	m_cancel = false;

	AddSequential(new WaitCommand(wait));
	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, false, 0, Drive::fNewMark, 40, 0.6, 0));	// Drive forward, tip bin over
	AddSequential(new DriveAutoStrafe(&m_cancel, 3.0, true, Drive::eLeft, false, 0, Drive::fMark, 20, -0.5));	// 15  Strafe left
	AddSequential(new WaitCommand(1.25));																		// Wait for bin to settle
	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, false, 0, Drive::fMark, -22, 0.6, 0));	// Backup
	AddSequential(new ElevSetPosition(Elevator::pBinLoad));														// Lower elevator
	AddSequential(new ElevWaitForOnTarget());
	AddSequential(new DriveAutoDrive(&m_cancel, 2.0, true, Drive::eBoth, false, 0, Drive::fMark, 26, 0.4, 0));	// Drive forward, load bin

	AddSequential(new ElevSetPosition(Elevator::pCarry));														// Raise elevator
	AddSequential(new ElevWaitForOnTarget());
	AddSequential(new DriveAutoDrive(&m_cancel, 2.0, true, Drive::eBoth, false, 0, Drive::fMark, 4, 0.6, 0));	// Drive forward, push bin in
}

bool AutoBinToWall::IsFinished() {
	return m_cancel ? true : CommandGroup::IsFinished();
}
