#include "AllCommands.h"

AutoBinToZoneL::AutoBinToZoneL(double wait) {
	m_cancel = false;

	AddSequential(new WaitCommand(wait));
	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, true, 0, Drive::fNewMark, 42, 0.5, 0));				// Drive forward, tip bin over
	AddSequential(new ElevSetToteCenter(Elevator::sOn));																	// Use kickers to grab bin
	AddSequential(new DriveAutoDriveStrafe(&m_cancel, 0, true, Drive::eLeft, true, 0, Drive::fMark, -170, 0.6, 0, 0.6));	// Drive-Strafe backwards to left side rail
	AddSequential(new ElevSetToteCenter(Elevator::sOff));																	// Release bin
}

bool AutoBinToZoneL::IsFinished() {
	return m_cancel ? true : CommandGroup::IsFinished();
}

