#include "AllCommands.h"

AutoToteBinToZoneL::AutoToteBinToZoneL(double wait) {
	m_cancel = false;

	AddSequential(new WaitCommand(wait));
	AddSequential(new ElevSetPosition(Elevator::pBinRelease));													// Raise elevator with tote
	AddSequential(new ElevWaitForOnTarget());
	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, false, 0, Drive::fNewMark, 48, 0.6, 0));	// Drive forward, tip bin over
	AddSequential(new ElevSetToteCenter(Elevator::sOn));														// Grab bin with kickers
	AddSequential(new DriveAutoRotate(&m_cancel, 0, 90, Drive::fMark, 0.7));									// Rotate 90 degrees
	AddSequential(new ElevSetToteCenter(Elevator::sOff));														// Release bin
	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, true, 90, Drive::fMark, 100, 0.5, 0));	// Drive forward to auto zone
	AddSequential(new ElevSetToteCenter(Elevator::sOn));														// Grab bin with kickers
	AddSequential(new DriveAutoRotate(&m_cancel, 0, 0, Drive::fMark, 0.7));										// Rotate front to left side rail
	AddSequential(new ElevSetToteCenter(Elevator::sOff));														// Release bin
	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, true, 0, Drive::fMark, -18, 0.5, 0));	// Backup
}

bool AutoToteBinToZoneL::IsFinished() {
	return m_cancel ? true : CommandGroup::IsFinished();
}

