#include "AllCommands.h"

AutoToteToZone::AutoToteToZone(double wait) {
	m_cancel = false;

	AddSequential(new WaitCommand(wait));
	AddSequential(new ElevSetPosition(Elevator::pStep));														// Raise elevator with tote
	AddSequential(new ElevWaitForOnTarget());
	AddSequential(new DriveAutoRotate(&m_cancel, 0, 90, Drive::fNewMark, 0.7));									// Rotate 90 degrees
	AddSequential(new DriveAutoDrive(&m_cancel, 0, true, Drive::eBoth, true, 90, Drive::fMark, 100, 0.4, 0));	// Drive forward to auto zone
}

bool AutoToteToZone::IsFinished() {
	return m_cancel ? true : CommandGroup::IsFinished();
}


