#include "AllCommands.h"

DriveAutoDriveStrafe::DriveAutoDriveStrafe(bool* cancel, double timeout, bool resetEncoder, Drive::DriveEncoder useEncoder, bool useBrake,
										   float angle, Drive::AngleFrom angleFrom, double target, float driveMax, float driveRamp,
										   float strafeMax) {
	Requires(MyRobot::drive);

	m_cancel = cancel;
	m_timeout = timeout;
	m_resetEncoder = resetEncoder;
	m_useEncoder = useEncoder;
	m_useBrake = useBrake;
	m_angle = angle;
	m_angleFrom = angleFrom;
	m_target = target;
	m_driveMax = driveMax;
	m_strafeMax = strafeMax;
	m_driveRamp = driveRamp;
}

void DriveAutoDriveStrafe::Initialize() {
	if (m_timeout > 0) SetTimeout(m_timeout);
	MyRobot::drive->InitAutoDriveStrafe(m_resetEncoder, m_useEncoder, m_useBrake, m_angle, m_angleFrom, m_target, 0, m_driveMax, m_driveRamp, m_strafeMax);
}

void DriveAutoDriveStrafe::Execute() {
}

bool DriveAutoDriveStrafe::IsFinished() {
	if (IsTimedOut()) {
		MyRobot::robotLog->Write("Drive:    Auto DriveStrafe Timeout");
		*m_cancel = true;
		return true;
	}

	return MyRobot::drive->IsOnTarget();
}

void DriveAutoDriveStrafe::End() {
	MyRobot::drive->CancelCommand();
}

void DriveAutoDriveStrafe::Interrupted() {
	MyRobot::drive->CancelCommand();
	MyRobot::robotLog->Write("Command Interrupt: DriveAutoDriveStrafe");
}
