#include "AllCommands.h"

DriveAutoDriveTurn::DriveAutoDriveTurn(bool* cancel, double timeout, bool resetEncoder, Drive::DriveEncoder useEncoder, bool useBrake,
									   float angle, Drive::AngleFrom angleFrom, double target, float driveMax, float driveRamp,
									   float rotateMax) {
	Requires(MyRobot::drive);

	m_cancel = cancel;
	m_timeout = timeout;
	m_resetEncoder = resetEncoder;
	m_useEncoder = useEncoder;
	m_useBrake = useBrake;
	m_angle = angle;
	m_angleFrom = angleFrom;
	m_target = target;
	m_driveMax = driveMax;
	m_rotateMax = rotateMax;
	m_driveRamp = driveRamp;
}

void DriveAutoDriveTurn::Initialize() {
	if (m_timeout > 0) SetTimeout(m_timeout);
	MyRobot::drive->InitAutoDriveTurn(m_resetEncoder, m_useEncoder, m_useBrake, m_angle, m_angleFrom, m_target, 0, m_driveMax,
			                          m_driveRamp, m_rotateMax);
}

void DriveAutoDriveTurn::Execute() {
}

bool DriveAutoDriveTurn::IsFinished() {
	if (IsTimedOut()) {
		MyRobot::robotLog->Write("Drive:    Auto DriveTurn Timeout");
		*m_cancel = true;
		return true;
	}

	return MyRobot::drive->IsOnTarget();
}

void DriveAutoDriveTurn::End() {
	MyRobot::drive->CancelCommand();
}

void DriveAutoDriveTurn::Interrupted() {
	MyRobot::drive->CancelCommand();
	MyRobot::robotLog->Write("Command Interrupt: DriveAutoDriveTurn");
}
