#include "AllCommands.h"

DriveAutoRotate::DriveAutoRotate(bool* cancel, double timeout, float angle, Drive::AngleFrom from, float rotateMax) {
	Requires(MyRobot::drive);

	m_cancel = cancel;
	m_timeout = timeout;
	m_angle = angle;
	m_angleFrom = from;
	m_rotateMax = rotateMax;
}

void DriveAutoRotate::Initialize() {
	if (m_timeout > 0) SetTimeout(m_timeout);
	MyRobot::drive->InitAutoRotate(m_angle, m_angleFrom, m_rotateMax);
}


void DriveAutoRotate::Execute() {
}

bool DriveAutoRotate::IsFinished() {
	if (IsTimedOut()) {
		MyRobot::robotLog->Write("Drive:    Auto Rotate Timeout");
		*m_cancel = true;
		return true;
	}

	return MyRobot::drive->IsOnTarget();
}

void DriveAutoRotate::End() {
	MyRobot::drive->CancelCommand();
}

void DriveAutoRotate::Interrupted() {
	MyRobot::drive->CancelCommand();
	MyRobot::robotLog->Write("Command Interrupt: DriveAutoDriveRotate");

}

