#include "AllCommands.h"

DriveAutoStrafe::DriveAutoStrafe(bool* cancel, double timeout, bool resetEncoder, Drive::DriveEncoder useEncoder, bool useBrake,
								 float angle, Drive::AngleFrom angleFrom, double target, float strafeMax) {
	Requires(MyRobot::drive);

	m_cancel = cancel;
	m_timeout = timeout;
	m_resetEncoder = resetEncoder;
	m_useEncoder = useEncoder;
	m_useBrake = useBrake;
	m_angle = angle;
	m_angleFrom = angleFrom;
	m_target = target;
	m_strafeMax = strafeMax;
}

void DriveAutoStrafe::Initialize() {
	if (m_timeout > 0) SetTimeout(m_timeout);
	MyRobot::drive->InitAutoStrafe(m_resetEncoder, m_useEncoder, m_useBrake, m_angle, m_angleFrom, m_target, 0, m_strafeMax);
}


void DriveAutoStrafe::Execute() {
}

bool DriveAutoStrafe::IsFinished() {
	if (IsTimedOut()) {
		MyRobot::robotLog->Write("Drive:    Auto Strafe Timeout");
		*m_cancel = true;
		return true;
	}

	return MyRobot::drive->IsOnTarget();
}

void DriveAutoStrafe::End() {
	MyRobot::drive->CancelCommand();
}

void DriveAutoStrafe::Interrupted() {
	MyRobot::drive->CancelCommand();
	MyRobot::robotLog->Write("Command Interrupt: DriveAutoStrafe");
}
