#include "AllCommands.h"

ElevCanGrab::ElevCanGrab(Elevator::SolenoidState state, double delay) {
	Requires(MyRobot::elevator);
	m_state= state;
	m_delay = delay;
}

void ElevCanGrab::Initialize() {
	if (m_delay > 0) {
		SetTimeout(m_delay);
	} else {
		MyRobot::elevator->SetCanGrab(m_state);
	}
}

void ElevCanGrab::Execute() {
}

bool ElevCanGrab::IsFinished() {
	if (m_delay > 0) {
		if (IsTimedOut()) {
			MyRobot::elevator->SetCanGrab(m_state);
			return true;
		} else {
			return false;
		}
	} else {
		return true;
	}
}

void ElevCanGrab::End() {
}

void ElevCanGrab::Interrupted() {
	MyRobot::robotLog->Write("Command Interrupt: ElevCanGrab");
}
