#include "OI.h"
#include "Commands/AllCommands.h"

OI::OI() {
	driveJoystick = new Joystick(0);
	elevJoystick = 	new Joystick(1);
	buttonBox = 	new Joystick(2);

	jbDriveWithStrafe1= 	new JoystickButton(driveJoystick, 1);		// Drive=Y;  Strafe=X;  Rotate=Gyro
	jbDriveWithStrafe2= 	new JoystickButton(driveJoystick, 11);		// Drive=Y;  Strafe=X;  Rotate=Gyro
	jbDriveOnlyStrafe1 =	new JoystickButton(driveJoystick, 3);		// Drive=0;  Strafe=X;  Rotate=Gyro
	jbDriveOnlyStrafe2 =	new JoystickButton(driveJoystick, 10);		// Drive=0;  Strafe=X;  Rotate=Gyro
	jbDriveSetWithGyro = 	new JoystickButton(driveJoystick, 9);		// Set Feeder Angle using Gyro
	jbDriveSetWithSonar =	new JoystickButton(driveJoystick, 6);		// Set Feeder Angle using Sonar
//	jbDriveSetWithGyro = 	new JoystickButton(driveJoystick, 6);		// Set Feeder Angle using Gyro
//	jbDriveSetWithSonar =	new JoystickButton(driveJoystick, 8);		// Set Feeder Angle using Sonar

	jbElevStep =			new JoystickButton(elevJoystick, 6);
	jbElevStepUnload =		new JoystickButton(elevJoystick, 7);
	jbToteEject1 =			new JoystickButton(elevJoystick, 8);
	jbToteEject2 =			new JoystickButton(elevJoystick, 9);
	jbElevStepToteUnload =	new JoystickButton(elevJoystick, 10);
	jbElevStepTote =		new JoystickButton(elevJoystick, 11);

	jbElevFeederLoad = 		new JoystickButton(buttonBox, 1);
	jbElevLiftFromTote =	new JoystickButton(buttonBox, 2);
	jbElevLiftFromFloor =	new JoystickButton(buttonBox, 3);
	jbElevBinLoad =			new JoystickButton(buttonBox, 4);
	jbCanGrabRetract = 		new JoystickButton(buttonBox, 5);
	jbCanGrabExtend =		new JoystickButton(buttonBox, 6);
	jbElevBinRelease =		new JoystickButton(buttonBox, 7);
//	jbStackHold = 			new JoystickButton(buttonBox, 8);
	jbElevCarry = 			new JoystickButton(buttonBox, 9);
	jbToteCenter =			new JoystickButton(buttonBox, 10);

	jbDriveWithStrafe1->WhenPressed     (new DriveSetMode(Drive::mDriveStrafe));
	jbDriveWithStrafe1->WhenReleased    (new DriveSetMode(Drive::mDriveRotate));
	jbDriveWithStrafe2->WhenPressed     (new DriveSetMode(Drive::mDriveStrafe));
	jbDriveWithStrafe2->WhenReleased    (new DriveSetMode(Drive::mDriveRotate));

	jbDriveOnlyStrafe1->WhenPressed		(new DriveSetMode(Drive::mStrafe));
	jbDriveOnlyStrafe1->WhenReleased    (new DriveSetMode(Drive::mDriveRotate));
	jbDriveOnlyStrafe2->WhenPressed		(new DriveSetMode(Drive::mStrafe));
	jbDriveOnlyStrafe2->WhenReleased    (new DriveSetMode(Drive::mDriveRotate));

	jbDriveSetWithGyro->WhenPressed		(new DriveSetFeederAngle(false));
	jbDriveSetWithSonar->WhenPressed	(new DriveSetFeederAngle(true));

	jbElevStep->WhenPressed				(new ElevSetPosition(Elevator::pStep));
	jbElevStepUnload->WhenPressed		(new ElevSetPosition(Elevator::pStepUnload));
	jbElevStepToteUnload->WhenPressed	(new ElevSetPosition(Elevator::pStepToteUnload));
	jbElevStepTote->WhenPressed			(new ElevSetPosition(Elevator::pStepTote));

	jbToteEject1->WhenPressed			(new ElevSetToteEject(Elevator::sOn));
	jbToteEject1->WhenReleased			(new ElevSetToteEject(Elevator::sOff));
	jbToteEject2->WhenPressed			(new ElevSetToteEject(Elevator::sOn));
	jbToteEject2->WhenReleased			(new ElevSetToteEject(Elevator::sOff));

    jbElevFeederLoad->WhenPressed		(new ElevSetPosition(Elevator::pFeederLoad));
	jbElevLiftFromTote->WhenPressed		(new ElevSetPosition(Elevator::pLiftFromTote));
	jbElevLiftFromFloor->WhenPressed	(new ElevSetPosition(Elevator::pLiftFromFloor));
	jbElevBinLoad->WhenPressed			(new ElevSetPosition(Elevator::pBinLoad));
	jbCanGrabExtend->WhenPressed		(new ElevCanGrab(Elevator::sOn, 0));
	jbCanGrabRetract->WhenPressed		(new ElevCanGrab(Elevator::sOff, 0));
	jbElevBinRelease->WhenPressed		(new ElevSetPosition(Elevator::pBinRelease));
	jbElevCarry->WhenPressed			(new ElevSetPosition(Elevator::pCarry));
	jbToteCenter->WhenPressed			(new ElevSetToteCenter(Elevator::sOn));
	jbToteCenter->WhenReleased			(new ElevSetToteCenter(Elevator::sOff));
//	jbStackHold->WhenPressed			(new ElevSetStackHold(Elevator::sOn));
//	jbStackHold->WhenReleased			(new ElevSetStackHold(Elevator::sOff));
}

bool OI::GetCameraButton() {
	return false;
//	return driveJoystick->GetRawButton(11);
}

float OI::GetDrive() {
	return -ApplyDeadband(driveJoystick->GetY(), 0.05);
}

float OI::GetElevator(){
	return ApplyDeadband(elevJoystick->GetY(), 0.05);
}

bool OI::GetElevatorButton() {
	return elevJoystick->GetRawButton(1);
}

bool OI::GetFeederDriveButton() {
	return driveJoystick->GetRawButton(8);								// Drive and Rotate to Feeder
//	return driveJoystick->GetRawButton(7);								// Drive and Rotate to Feeder
}

bool OI::GetFeederRotateButton() {										// Rotate to Feeder
	return driveJoystick->GetRawButton(7);
//	return driveJoystick->GetRawButton(9);
}

float OI::GetRotate() {
	float joyValue = ApplyDeadband(driveJoystick->GetX(), 0.10);
	joyValue = (joyValue >= 0) ? joyValue * joyValue : -joyValue * joyValue;
	return joyValue;
}

bool OI::GetStackHoldButton() {
	return buttonBox->GetRawButton(8);
}

float OI::GetStrafe() {
	return ApplyDeadband(driveJoystick->GetX(), 0.05);
}


// ******************** PRIVATE ********************

float OI::ApplyDeadband(float rawValue, float deadband) {
	rawValue = Limit(rawValue);

	if(fabs(rawValue) < deadband) return 0.0;
	if(rawValue > 0)			  return (rawValue - deadband) / (1.0 - deadband);
								  return (rawValue + deadband) / (1.0 - deadband);
}

float OI::Limit(float value) {
	if(value > 1.0)  return 1.0;
	if(value < -1.0) return -1.0;
					 return value;
}
