#ifndef OI_H
#define OI_H

#include "WPILib.h"

class OI {
public:
	OI();

	bool	GetCameraButton();
	float 	GetDrive();
	float 	GetElevator();
	bool    GetElevatorButton();
	bool	GetFeederDriveButton();
	bool	GetFeederRotateButton();
	float 	GetRotate();
	bool    GetStackHoldButton();
	float 	GetStrafe();

private:
	Joystick* 		driveJoystick;
	Joystick*		elevJoystick;
	Joystick*       buttonBox;

	JoystickButton* jbDriveWithStrafe1;
	JoystickButton* jbDriveWithStrafe2;
	JoystickButton* jbDriveOnlyStrafe1;
	JoystickButton* jbDriveOnlyStrafe2;
	JoystickButton* jbDriveSetWithGyro;
	JoystickButton* jbDriveSetWithSonar;

	JoystickButton* jbElevStep;
	JoystickButton* jbElevStepUnload;
	JoystickButton* jbToteEject1;
	JoystickButton* jbToteEject2;
	JoystickButton* jbElevStepToteUnload;
	JoystickButton* jbElevStepTote;

	JoystickButton* jbElevFeederLoad;
	JoystickButton* jbElevLiftFromTote;
	JoystickButton* jbElevLiftFromFloor;
	JoystickButton* jbElevBinLoad;
	JoystickButton* jbCanGrabExtend;
	JoystickButton* jbCanGrabRetract;
	JoystickButton* jbElevBinRelease;
	JoystickButton* jbElevCarry;
//	JoystickButton* jbStackHold;
	JoystickButton* jbToteCenter;

	float ApplyDeadband(float rawValue, float deadband);
	float Limit(float value);
};

#endif
